﻿using System;
using System.Collections.Generic;
using Infragistics.Olap;
using Infragistics.Olap.Data;
using Infragistics.Olap.Xmla;

namespace OlapAxisWithXMLA
{
    /// <summary>
    /// Defines objects needed to execute an Adomd command
    /// </summary>
    public class AdomdCommandExecution
    {
        /// <summary>
        /// The Query
        /// </summary>
        public IMdxQuery Query { get; set; }
        /// <summary>
        /// The connection
        /// </summary>
        public XmlaConnection Connection { get; set; }
        /// <summary>
        /// Should the command be executed with the selected filters
        /// </summary>
        public bool RemoveFilters { get; set; }
        /// <summary>
        /// The result of the query
        /// </summary>
        public IResult Result { get; set; }
    }

    /// <summary>
    /// Groups multiple related Adomd commands
    /// </summary>
    public class AdomdCommandGroup
    {
        /// <summary>
        /// List of Adomd commands to execute
        /// </summary>
        public List<AdomdCommandExecution> AdomdCommandExecutions { get; set; }
        /// <summary>
        /// The index of the command to execute
        /// </summary>
        public int CommandIndex { get; set; }
    }

    /// <summary>
    /// the event args for executing multiple Adomd commands
    /// </summary>
    public class ExecuteMultipleCommandsCompletedEventArgs : EventArgs
    {
        /// <summary>
        /// 
        /// </summary>
        public List<ExecuteCommandCompletedEventArgs> ExecuteCommandCompletedEventArgs { get; set; }
    }
}
