﻿using Infragistics.Olap;
using Infragistics.Olap.Xmla;
using System.ComponentModel;

namespace OlapAxisWithXMLA
{
    public class AdomdConnection : XmlaConnection
    {
        static AdomdConnection()
        {
            var commandComposition = new OlapComposition();
            commandComposition.AddOlapPart<AdomdCommand>(typeof(XmlaConnection));
            commandComposition.AddOlapPart<AdomdConnection>();
            OlapContainer<XmlaCommand>.Instance.Register(typeof(AdomdConnection), commandComposition);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="settings"></param>
        public AdomdConnection(IConnectionSettings settings)
            : base(settings)
        {
        }

    }

    public class AdomdConnectionSettings : IConnectionSettings
    {
        static AdomdConnectionSettings()
        {
            var olapComposition = new OlapComposition();
            olapComposition.AddOlapPart<XmlaDataSource>(typeof(IDataProvider));
            olapComposition.AddOlapPart<AdomdDataProvider>(typeof(IOlapConnection));
            olapComposition.AddOlapPart<AdomdConnection>(typeof(IConnectionSettings));
            olapComposition.AddOlapPart<AdomdConnectionSettings>();
            OlapContainer<IOlapViewModel>.Instance.Register(typeof(AdomdConnectionSettings), olapComposition);

            var dataProviderComposition = new OlapComposition();
            dataProviderComposition.AddOlapPart<AdomdDataProvider>(typeof(IOlapConnection));
            dataProviderComposition.AddOlapPart<AdomdConnection>(typeof(IConnectionSettings));
            dataProviderComposition.AddOlapPart<AdomdConnectionSettings>();
            OlapContainer<IDataProvider>.Instance.Register(typeof(AdomdConnectionSettings), dataProviderComposition);

            var filterComposition = new OlapComposition();
            //filterComposition.AddOlapPart<FilterViewModelBase>(typeof(IDataProvider), typeof(ICube), typeof(IHierarchy), typeof(bool));
            filterComposition.AddOlapPart<FilterViewModelBase>(typeof(IOlapViewModel), typeof(IDataProvider), typeof(Infragistics.Olap.Data.ICube), typeof(Infragistics.Olap.Data.IHierarchy));
            //filterComposition.AddOlapPart<FilterViewModelBase>();
            filterComposition.AddOlapPart<AdomdDataProvider>(typeof(IOlapConnection));
            filterComposition.AddOlapPart<AdomdConnection>(typeof(IConnectionSettings));
            filterComposition.AddOlapPart<AdomdConnectionSettings>();
            filterComposition.AddOlapPart<Infragistics.Olap.Data.Base.Cube>();
            filterComposition.AddOlapPart<Infragistics.Olap.Data.Base.Hierarchy>();
            OlapContainer<IFilterViewModel>.Instance.Register(typeof(AdomdConnectionSettings), filterComposition);

            var measureComposition = new OlapComposition();
            measureComposition.AddOlapPart<BaseMeasureViewModel>(typeof(IOlapViewModel), typeof(IDataProvider), typeof(Infragistics.Olap.Data.ICube), typeof(Infragistics.Olap.Data.IMeasure));
            measureComposition.AddOlapPart<AdomdDataProvider>(typeof(IOlapConnection));
            measureComposition.AddOlapPart<AdomdConnection>(typeof(IConnectionSettings));
            measureComposition.AddOlapPart<AdomdConnectionSettings>();
            measureComposition.AddOlapPart<Infragistics.Olap.Data.Base.Cube>();
            measureComposition.AddOlapPart<Infragistics.Olap.Data.Base.Measure>();
            OlapContainer<IMeasureViewModel>.Instance.Register(typeof(AdomdConnectionSettings), measureComposition);
        }
    }
}
